------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                           SQL Database Access                            --
--                                                                          --
--                              Tools Component                             --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2011, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 1643 $ $Date: 2011-03-25 23:49:48 +0300 (Fri, 25 Mar 2011) $
------------------------------------------------------------------------------
--  This procedure import OCIEnvNlsCreate and contains call to it.
--  If OCI is not available this result linker error.
------------------------------------------------------------------------------

with Interfaces.C;
with System;

procedure Main is

   use Interfaces;

   subtype Sword is C.int;

   type Handle is access all Unsigned_32;

   function Env_NLS_Create
     (Target    : access Handle;
      Mode      : Unsigned_32;
      Ctxp      : System.Address := System.Null_Address;
      Malocfp   : System.Address := System.Null_Address;
      Ralocfp   : System.Address := System.Null_Address;
      Mfreefp   : System.Address := System.Null_Address;
      Extra_Sz  : C.size_t := 0;
      Extra_Ptr : System.Address := System.Null_Address;
      Charset   : Unsigned_16 := 1000;
      N_Charset : Unsigned_16 := 1000)
     return Sword;

   pragma Import (C, Env_NLS_Create,    "OCIEnvNlsCreate");


   Code : Sword;
   Env  : aliased Handle;

begin
   Code := Env_NLS_Create (Env'Access, 1);
end Main;
