------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--         Localization, Internationalization, Globalization for Ada        --
--                                                                          --
--                            Testsuite Component                           --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2011, Vadim Godunko <vgodunko@gmail.com>                --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 1298 $ $Date: 2011-01-11 02:39:40 +0300 (Tue, 11 Jan 2011) $
------------------------------------------------------------------------------
with League.Application;
with League.Strings;

procedure Case_Folding_Test is

   use League.Strings;

   --  Check \u00DF correctly transformed to \u0073\u0073 sequence and
   --  Final_Sigma casing context is never used.

   S1S : Universal_String
     := To_Universal_String
         (Wide_Wide_Character'Val (16#00DF#)
            & 'A' & Wide_Wide_Character'Val (16#03A3#) & 'Z');
   S1E : constant Wide_Wide_String
     := Wide_Wide_Character'Val (16#0073#)
          & Wide_Wide_Character'Val (16#0073#)
          & 'a' & Wide_Wide_Character'Val (16#03C3#) & 'z';
   S2S : Universal_String
     := To_Universal_String
         ('A' & Wide_Wide_Character'Val (16#03A3#));
   S2E : constant Wide_Wide_String
     := 'a' & Wide_Wide_Character'Val (16#03C3#);

begin
   if S1S.To_Casefold.To_Wide_Wide_String /= S1E then
      raise Program_Error;
   end if;

   if S2S.To_Casefold.To_Wide_Wide_String /= S2E then
      raise Program_Error;
   end if;
end Case_Folding_Test;
