------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                               Web Framework                              --
--                                                                          --
--                            Testsuite Component                           --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3475 $ $Date: 2012-11-23 22:46:35 +0400 (Fri, 23 Nov 2012) $
------------------------------------------------------------------------------
with League.Strings;
private with XML.SAX.Attributes;

with Web_Services.SOAP.Payloads.Decoders;

package SOAPConf.Decoders is

   type Test_Payload_Decoder is
     limited new Web_Services.SOAP.Payloads.Decoders.SOAP_Payload_Decoder
       with private;

private

   type Test_Payload_Decoder is
     limited new Web_Services.SOAP.Payloads.Decoders.SOAP_Payload_Decoder with
   record
      Collect : Boolean := False;
      Text    : League.Strings.Universal_String;
      Payload : Web_Services.SOAP.Payloads.SOAP_Payload_Access;
   end record;

   overriding function Create
    (URI : not null access League.Strings.Universal_String)
       return Test_Payload_Decoder;

   overriding procedure Characters
    (Self    : in out Test_Payload_Decoder;
     Text    : League.Strings.Universal_String;
     Success : in out Boolean);

   overriding function Payload
    (Self : Test_Payload_Decoder)
       return not null Web_Services.SOAP.Payloads.SOAP_Payload_Access;

   overriding procedure End_Element
    (Self           : in out Test_Payload_Decoder;
     Namespace_URI  : League.Strings.Universal_String;
     Local_Name     : League.Strings.Universal_String;
     Success        : in out Boolean);

   overriding procedure Start_Element
    (Self           : in out Test_Payload_Decoder;
     Namespace_URI  : League.Strings.Universal_String;
     Local_Name     : League.Strings.Universal_String;
     Attributes     : XML.SAX.Attributes.SAX_Attributes;
     Success        : in out Boolean);

end SOAPConf.Decoders;
